/*
 * Semantic Similarity API
 *
 * This API computes the simlarity of RDF entities
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.SemanticSimilarity.Core.Client.OpenAPIDateConverter;

namespace Coscine.SemanticSimilarity.Core.Model
{
    /// <summary>
    /// SimilarityInput
    /// </summary>
    [DataContract(Name = "SimilarityInput")]
    public partial class SimilarityInput : IEquatable<SimilarityInput>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SimilarityInput" /> class.
        /// </summary>
        /// <param name="graphs">graphs.</param>
        /// <param name="methods">methods.</param>
        public SimilarityInput(List<DefinitionObject> graphs = default(List<DefinitionObject>), List<string> methods = default(List<string>))
        {
            this.Graphs = graphs;
            this.Methods = methods;
        }

        /// <summary>
        /// Gets or Sets Graphs
        /// </summary>
        [DataMember(Name = "graphs", EmitDefaultValue = false)]
        public List<DefinitionObject> Graphs { get; set; }

        /// <summary>
        /// Gets or Sets Methods
        /// </summary>
        [DataMember(Name = "methods", EmitDefaultValue = false)]
        public List<string> Methods { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SimilarityInput {\n");
            sb.Append("  Graphs: ").Append(Graphs).Append("\n");
            sb.Append("  Methods: ").Append(Methods).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SimilarityInput);
        }

        /// <summary>
        /// Returns true if SimilarityInput instances are equal
        /// </summary>
        /// <param name="input">Instance of SimilarityInput to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SimilarityInput input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Graphs == input.Graphs ||
                    this.Graphs != null &&
                    input.Graphs != null &&
                    this.Graphs.SequenceEqual(input.Graphs)
                ) && 
                (
                    this.Methods == input.Methods ||
                    this.Methods != null &&
                    input.Methods != null &&
                    this.Methods.SequenceEqual(input.Methods)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Graphs != null)
                {
                    hashCode = (hashCode * 59) + this.Graphs.GetHashCode();
                }
                if (this.Methods != null)
                {
                    hashCode = (hashCode * 59) + this.Methods.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
